
(define qq
  (expand
   '(defmacro quasiquote (x)
      (let ([normal
	     (lambda (x old)
	       (if (#%eq? x old)
		   (#%list 'quote x)
		   x))])
	(normal
	 (let qq ([x x][level 0])
	   (let ([qq-list
		  (lambda (x car-level cdr-level)
		    (let* ([old-first (#%car x)]
			   [old-second (#%cdr x)]
			   [first (qq old-first car-level)]
			   [second (qq old-second cdr-level)])
		      (if (#%and (#%eq? first old-first)
				 (#%eq? second old-second))
			  x
			  (#%list '#%cons 
				  (normal first old-first)
				  (normal second old-second)))))])
	     (#%cond
	      [(#%pair? x)
	       (let ([first (#%car x)])
		 (#%cond
		  [(#%eq? first 'unquote)
		   (if (#%zero? level)
		       (let ([rest (#%cdr x)])
			 (if (#%or (#%not (#%pair? rest))
				   (#%not (#%null? (#%cdr rest))))
			     (#%error 
			      "unqoute: takes exactly one expression"))
			 (#%car rest))
		       (qq-list x level (#%sub1 level)))]
		  [(#%eq? first 'quasiquote)
		   (qq-list x level (#%add1 level))]
		  [(#%and (#%pair? first)
			  (#%eq? (#%car first) 'unquote-splicing))
		   (let ([rest (#%cdr first)])
		     (if (#%or (#%not (#%pair? rest))
			       (#%not (#%null? (#%cdr rest))))
			 (#%error 
			  "unqoute-splicing: takes exactly one expression"))
		     (if (#%null? (#%cdr x))
			 (#%car rest)
			 (let* ([old-l (#%cdr x)]
				[l (qq old-l level)]
				[l (normal l old-l)])
			   (#%list '#%append (#%car rest) l))))]
		  [else
		   (qq-list x level level)]))]
	      [(#%vector? x)
	       (let* ([l (#%vector->list x)]
		      [l2 (qq l level)])
		 (if (#%eq? l l2)
		     x
		     (#%list '#%list->vector l2)))]
	      [else x])))
	 x)))
   ))

